/*
 * uc_lbr.h
 *
 * Created: 20.11.2011 16:42:33
 *  Author: Bus Ondrej
 */ 


#ifndef _UC_LBR_H_
#define _UC_LBR_H_

#include <avr/io.h>
#include <avr/sfr_defs.h>
#include <util/delay.h>

#define PWR_READY_PORT		PIND
#define PWR_READY_DDR		DDRD
#define PWR_READY_PIN		3
#define USB_READY_PORT		PIND
#define USB_READY_DDR		DDRD
#define USB_READY_PIN		0
#define CLK_CONTROL_PORT	PORTB
#define CLK_CONTROL_DDR		DDRB
#define CLK_CONTROL_PIN		3

#define ROT_CTRL_A_H_PIN	1
#define ROT_CTRL_A_PIN		HEADER_1_PIN
#define	ROT_CTRL_A_DDR		HEADER_1_DDR
#define ROT_CTRL_A_1_H_PIN	8
#define ROT_CTRL_A_1_PIN	HEADER_8_PIN
#define ROT_CTRL_A_2_H_PIN	7
#define ROT_CTRL_A_2_PIN	HEADER_7_PIN
#define ROT_CTRL_A_3_H_PIN	15
#define ROT_CTRL_A_3_PIN	HEADER_15_PIN
#define ROT_CTRL_A_4_H_PIN	14
#define ROT_CTRL_A_4_PIN	HEADER_14_PIN
#define ROT_CTRL_B_H_PIN	13
#define ROT_CTRL_B_PIN		HEADER_13_PIN
#define	ROT_CTRL_B_DDR		HEADER_13_DDR
#define ROT_CTRL_B_1_H_PIN	14
#define ROT_CTRL_B_1_PIN	HEADER_14_PIN
#define ROT_CTRL_B_2_H_PIN	15
#define ROT_CTRL_B_2_PIN	HEADER_15_PIN
#define ROT_CTRL_B_3_H_PIN	7
#define ROT_CTRL_B_3_PIN	HEADER_7_PIN
#define ROT_CTRL_B_4_H_PIN	8
#define ROT_CTRL_B_4_PIN	HEADER_8_PIN
#define ROT_CTRL_A_1_DDR	HEADER_8_DDR
#define ROT_CTRL_A_2_DDR	HEADER_7_DDR
#define ROT_CTRL_A_3_DDR	HEADER_15_DDR
#define ROT_CTRL_A_4_DDR	HEADER_14_DDR
#define ROT_CTRL_B_1_DDR	ROT_CTRL_A_4_DDR
#define ROT_CTRL_B_2_DDR	ROT_CTRL_A_3_DDR
#define ROT_CTRL_B_3_DDR	ROT_CTRL_A_2_DDR
#define ROT_CTRL_B_4_DDR	ROT_CTRL_A_1_DDR
#define ROT_CTRL_A			1
#define	ROT_CTRL_B			0
#define ROT_CTRL_BOTH		2
#define	PULL_UP_ON			1
#define	PULL_UP_OFF			0

#define ROT_CTRL_SEL_H_PIN	2
#define ROT_CTRL_SEL_PIN	HEADER_2_PIN
#define ROT_CTRL_SEL_DDR	HEADER_2_DDR

#define	BUT_EXTINTCLK_H_PIN	5
#define	BUT_EXTINTCLK_PIN	HEADER_5_PIN
#define	BUT_EXTINTCLK_DDR	HEADER_5_DDR

#define	LED_A_H_PIN			17
#define	LED_A_PIN			HEADER_17_PIN
#define	LED_A_DDR			HEADER_17_DDR
#define	LED_B_H_PIN			16
#define	LED_B_PIN			HEADER_16_PIN
#define	LED_B_DDR			HEADER_16_DDR
#define	LED_USB_H_PIN		6
#define	LED_USB_PIN			HEADER_6_PIN
#define	LED_USB_DDR			HEADER_6_DDR
#define	LED_EXTCLOCK_H_PIN	19
#define	LED_EXTCLOCK_PIN	HEADER_19_PIN
#define	LED_EXTCLOCK_DDR	HEADER_19_DDR
#define LED_ON				1
#define LED_OFF				0

//--------------------HEADER DEFINITION--------------------

#define	HEADER_1_PORT		PORTC
#define	HEADER_2_PORT		PORTC
#define	HEADER_4_PORT		PORTA
#define	HEADER_5_PORT		PORTA
#define	HEADER_6_PORT		PORTA
#define	HEADER_7_PORT		PORTA
#define	HEADER_8_PORT		PORTB
#define	HEADER_13_PORT		PORTB
#define	HEADER_14_PORT		PORTA
#define	HEADER_15_PORT		PORTA
#define	HEADER_16_PORT		PORTA
#define	HEADER_17_PORT		PORTA
#define	HEADER_18_PORT		PORTC
#define	HEADER_19_PORT		PORTC

#define	HEADER_1_PIN		4
#define	HEADER_2_PIN		6
#define	HEADER_4_PIN		6
#define	HEADER_5_PIN		4
#define	HEADER_6_PIN		2
#define	HEADER_7_PIN		0
#define	HEADER_8_PIN		1
#define	HEADER_13_PIN		0
#define	HEADER_14_PIN		1
#define	HEADER_15_PIN		3
#define	HEADER_16_PIN		5
#define	HEADER_17_PIN		7
#define	HEADER_18_PIN		7
#define	HEADER_19_PIN		5

#define	HEADER_1_WRITE		HEADER_1_PORT
#define	HEADER_2_WRITE		HEADER_2_PORT
#define	HEADER_4_WRITE		HEADER_4_PORT
#define	HEADER_5_WRITE		HEADER_5_PORT
#define	HEADER_6_WRITE		HEADER_6_PORT
#define	HEADER_7_WRITE		HEADER_7_PORT
#define	HEADER_8_WRITE		HEADER_8_PORT
#define	HEADER_13_WRITE		HEADER_13_PORT
#define	HEADER_14_WRITE		HEADER_14_PORT
#define	HEADER_15_WRITE		HEADER_15_PORT
#define	HEADER_16_WRITE		HEADER_16_PORT
#define	HEADER_17_WRITE		HEADER_17_PORT
#define	HEADER_18_WRITE		HEADER_18_PORT
#define	HEADER_19_WRITE		HEADER_19_PORT

#define	HEADER_1_READ		PIN(HEADER_1_PORT)
#define	HEADER_2_READ		PIN(HEADER_2_PORT)
#define	HEADER_4_READ		PIN(HEADER_4_PORT)
#define	HEADER_5_READ		PIN(HEADER_5_PORT)
#define	HEADER_6_READ		PIN(HEADER_6_PORT)
#define	HEADER_7_READ		PIN(HEADER_7_PORT)
#define	HEADER_8_READ		PIN(HEADER_8_PORT)
#define	HEADER_13_READ		PIN(HEADER_13_PORT)
#define	HEADER_14_READ		PIN(HEADER_14_PORT)
#define	HEADER_15_READ		PIN(HEADER_15_PORT)
#define	HEADER_16_READ		PIN(HEADER_16_PORT)
#define	HEADER_17_READ		PIN(HEADER_17_PORT)
#define	HEADER_18_READ		PIN(HEADER_18_PORT)
#define	HEADER_19_READ		PIN(HEADER_19_PORT)

#define	HEADER_1_DDR		DDR(HEADER_1_PORT)
#define	HEADER_2_DDR		DDR(HEADER_2_PORT)
#define	HEADER_4_DDR		DDR(HEADER_4_PORT)
#define	HEADER_5_DDR		DDR(HEADER_5_PORT)
#define	HEADER_6_DDR		DDR(HEADER_6_PORT)
#define	HEADER_7_DDR		DDR(HEADER_7_PORT)
#define	HEADER_8_DDR		DDR(HEADER_8_PORT)
#define	HEADER_13_DDR		DDR(HEADER_13_PORT)
#define	HEADER_14_DDR		DDR(HEADER_14_PORT)
#define	HEADER_15_DDR		DDR(HEADER_15_PORT)
#define	HEADER_16_DDR		DDR(HEADER_16_PORT)
#define	HEADER_17_DDR		DDR(HEADER_17_PORT)
#define	HEADER_18_DDR		DDR(HEADER_18_PORT)
#define	HEADER_19_DDR		DDR(HEADER_19_PORT)

//---------------------------------------------------------

#define INTERNAL			0										//pomocne konstanty
#define EXTERNAL			1

#define	DDR(x)				(*(&x - 1))								//adresa DDR registru
#define	PIN(x)				(*(&x - 2))								//adresa vstupniho registru PIN
#define GET_BIT(n, i)		((n >> i) & 0x01)						//ziskat bit "i" v registru "n"

void uc_init(void);													//inicializace uC ATMEGA16A
unsigned char pwr_ready(void);										//vraci 1 v pripade, ze je pripojeno 12V, jinak 0
unsigned char usb_ready(void);										//vraci 1 v pripade, ze je pripojeno napajeni USB, jinak 0
void clk_control(unsigned char h_ext_l_int);						//prepina mezi internim a externim zdrojem kmitoctu (INTERNAL/EXTERNAL)
void header_init(void);												//nastaveni smeru jednotlivych pinu na konektoru, prip. nastaveni pull-up rezistoru
unsigned char header_write(unsigned char pin, unsigned char value);	//zapis logickych hodnot na jednotlive piny konektoru
unsigned char header_read(unsigned char pin);						//funkce pro cteni logicke urovne na jednotlivych pinech konektoru, pokud je zadan neexistujici ci nepouzitelny pin vraci 2
unsigned char rot_ctrl_read(unsigned char rot_ctrl);				//funkce vraci nastavene polohy na otocnych prepinacich, vstup ROT_CTRL_A, ROT_CTRL_B nebo ROT_CTRL_BOTH (ve formatu 0bBBBBAAAA)
unsigned char rot_ctrl_sel(void);									//urcuje, zdali byla harwarove zvolena predvolba nastavena ovladacem A nebo B
unsigned char button_extintclk(void);								//obsluha tlacitka pro volbu zdroje hodinoveho kmitoctu
void led_usb(unsigned char on_off);									//obsluha LED "USB busy"
void led_extclk(unsigned char on_off);								//obsluha LED "External clock"
void led_a(unsigned char on_off);									//obsluha LED "A"
void led_b(unsigned char on_off);									//obsluha LED "B"

#endif /* _UC_LBR_H_ */